---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# Time Index Add Operator
---
## Operator 설명
- Unix time stamp pattern의 time index column을 갖는 DataFrame을 생성한다.
## Operator 파라미터 설명
- userTimeIndexColumnId: Unix time stamp로 변환할 column ID(in seconds) (required)
- userTimeIndexPattern: userTimeIndexColumn의 시간 형식 (required)

## 작동 순서
1. 입력 DataFrame 및 Protobuffer 입력 파라미터 유효성 검사를 진행한다.
2. Spark ml 및 DataFrame API를 이용하여 Unix time stamp column을 생성한다.
3. 출력 DataFrame을 생성한다.

## Operator 모듈 테스트 결과

### 입력 데이터


|DATE_TIME|
|:---:|
|2015_09_01_00_00|
|2015_09_01_00_05|
|2015_09_01_00_10|
|2015_09_01_00_15|
|2015_09_01_00_20|
|2015_09_01_00_25|
|2015_09_01_00_30|



### 결과 데이터
|DATE_TIME|timestamp|
|:---:|:---:|
|2015_09_01_00_00|2015-09-01 00:00:0.0
|2015_09_01_00_05|2015-09-01 00:05:0.0
|2015_09_01_00_10|2015-09-01 00:10:0.0
|2015_09_01_00_15|2015-09-01 00:15:0.0
|2015_09_01_00_20|2015-09-01 00:20:0.0
|2015_09_01_00_25|2015-09-01 00:25:0.0
|2015_09_01_00_30|2015-09-01 00:30:0.0

- Unix time stamp pattern을 갖는 새로운 timestamp column이 결과 DataFrame에 생성된 것을 알 수 있다.
