---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# Column Select Operator
---
## Operator 설명
- 원하는 여러 개의 column들을 선택하여 새로운 DataFrame을 생성한다.

## Operator 파라미터 설명
- selectedColumnId: 선택할 column ID (repeated)
- subParam: 선택 option (repeated) Ex: {"order","1000000300,1000000100,1000000200,1000000500"}
- selectedColumnName: 선택할 column 이름 (repeated)

## Operator 모듈 테스트 결과

### 입력 데이터
Country|	City|		CustomerID	|PostalCode|	CustomerName
|:---:|:---:|:---:|:---:|:---:|
Germany|Berlin|1|12209|Alfreds Futterkiste|
|Mexico   | México D.F.  |2   |05021   |  Ana Trujillo Emparedados y helados |
| Mexico  | México D.F.  |  3 |  05023 | Antonio Moreno Taquería  |
| UK  | London  | 4  |WA1 1DP| Around the Horn  |   
|  Sweden |  Luleå |5   |  S-958 22 |   Berglunds snabbköp|   

### 결과 데이터
CustomerID|	CustomerName|		City	|PostalCode|	Country
|:---:|:---:|:---:|:---:|:---:|
1| Alfreds Futterkiste|		Berlin|	12209|	Germany
2	|Ana Trujillo Emparedados y helados| México D.F.|	05021|	Mexico
3	|Antonio Moreno Taquería| México D.F.|	05023|	Mexico
4 |Around the Horn| 	London|	WA1 1DP|	UK|
5 |Berglunds snabbköp| Luleå|	S-958 22	|Sweden

- 원하는 column들을 순서대로 선택하여 원하는 결과 DataFrame을 생성할 수 있다. 위의 결과 DataFrame은 입력 DataFrame의 column 2,4,1,3,0을 순서대로 선택한 결과이고 parameter를 설정한 코드는 다음과 같다.

```scala
val selectedColumnInfo = SelectColumnInfo.newBuilder()
.addSelectedColumnId(2)
.addSelectedColumnId(4)
.addSelectedColumnId(1)
.addSelectedColumnId(3)
.addSelectedColumnId(0)
.build
```
