---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# Filter Operator
---
## Operator 설명
- 선택한 column에 대해 조건에 맞는 row를 선택하여 DataFrame을 생성한다.

## Operator 파라미터 설명
- columnName: 필터링 할 column 이름 (required)
- condition: row 선택 조건. Enum(EQUAL,LESS_THAN,LARGE_THAN,LESS_EQUAL,LARGE_EQUAL,EXIST,LIKE) (required)
- value: row를 선택할 때 비교의 기준이 되는 값(optional)
- pattern: DataFrame의 row에 문자열 값과 비교할 문자열 pattern (optional)
## Operator 모듈 테스트 결과

### 입력 데이터

|word|  count|
:--:|:--:|
|  I|       1|
|  am|      1|     
| so|       3|    
| happy|    4|        
| now|      2|        
|  are|     3|        
| you|      2|       
| happy|    6|     
| now|      8|   
| I|        1|  
| I|        3|
| I|        5|


### 결과 데이터

|word|  count|        
:--:|:--:|            
|  I|       1|
|  am|      1|            
| I|        1|  

- 다음과 같이 parameter를 설정하였다.
```scala
val filterInfo = FilterInfo.newBuilder()
  .setColName("count")
  .setCondition(FilterInfo.Condition.EQUAL)
  .setValue(1)
  .build
```
- count column에서 1과 같은 값을 갖고 있는 row들만 선택하여 DataFrame을 생성하였고 위와 같은 결과 DataFrame을 확인할 수 있다.
