---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# Filter Using Sql Operator
---
## Operator 설명
- SQL문을 이용하여 원하는 row 또는 column을 선택한 후 DataFrame을 생성한다.

## Operator 파라미터 설명
- selectedColumnId: 필터링 할 column ID (required)
- subParam: SQL을 사용하여 필터링 하는 option (repeated)
Ex: {"sql_where", "DATE_TIME < '2015_09_01_00_05' ORDER BY DATE_TIME"}

|filed|value|설명|
|:---:|:---:|:---:|
|subParam.key|  sql_where | 필터의 키값|
|subParam.value| DATE_TIME < '2015_09_01_00_05'ORDER BY DATE_TIME |필터의 조건|
## Operator 모듈 테스트 결과

### 입력 데이터

|id| name|city|state| zipcode|
:--:|:---:|:---:|:---:|:---:|
| 100|   John Smith|          Austin|      TX|78727|
| 200|   Joe Johnson|         Dallas|      TX|75201|
| 300|    Bob Jone|          Houston|      TX|77028|
| 400|     Andy Davis|   San Antonio|      TX|78227|
| 500|    James William|      Austin|      TX|78727|

### 결과 데이터


|         name|zipcode|
:--:|:--:|
|   John Smith|  78727|
|  Joe Johnson|  75201|
|     Bob Jone|  77028|
|   Andy Davis|  78227|
|James William|  78727|

``` sql
SQL Query:SELECT name,zipcode FROM data_temp WHERE id <'1000' ORDER BY id
```
- name, zipcode column에서 id <'1000'의 조건을 만족하는 값만 출력되었음을 확인할 수 있다.
