---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# Interpolate Operator
---
## Operator 설명
- Interpolation(보간)이란 알려진 지점의 값 사이에 위치한 값을 알려진 값으로부터 추정하는 것을 말한다.
  - LINEAR: 두 지점 사이의 값을 추정할 때 그 값을 두 지점과의 직선 거리에 따라 선형적으로 결정하는 방법이다.
  - NEAREST: 가장 가까운 점의 값을 선택하는 방법이다.
  - PREV_COPY: 이전 값을 선택하는 방법이다.

<img src="/images/4.1.1.29.interpolation.jpg" ><br>

    위키피디아,2018년8월20일,https://ko.wikipedia.org/wiki/선형_보간법

- 위의 그림과 같이 p1과 p2 사이에 있는 점 p의 값을 추정하기 위해 LINEAR, NEAREST, PREV_COPY 방법을 사용하여서 값을 결정할 수 있다.
## Operator 파라미터 설명
- indexColumnName: 인덱스 column의 이름. (required)
- stepSize: 인덱스 범위 간격 (required)
- methodOption: Interpolation(보간) 방법. Enum(LINEAR, NEAREST, PREV_COPY)(required)
- keepColumnType: 원래의 column type을 유지할 것인지 아닌지를 결정. (optional)
  Interpolation option 이후 column type은 double type으로 바뀐다.
## Operator 모듈 테스트 결과

### 입력 데이터

index|value1|value2|value3
|:---:|:---:|:---:|:---:|
1|8|3|4.8|
2|6|5|1.2|
5|4|6|6.5|
7|4|4|7.8|
8|10|8|5|
10|8|6|9|
12|4|4|16|
15|5|5|5|
17|6|6|4.2|
20|7|7|8|


### 결과 데이터
|index|value1|value2|value3|
|:---:|:---:|:---:|:---:|
1|8.0|3|4.8
2|6.0|5|1.2
3|6.0|5|1.2
4|4.0|6|6.5
5|4.0|6|6.5
6|4.0|6|6.5
7|4.0|4|7.8
8|10.0|8|5.0
9|10.0|8|5.0
10|8.0|6|9.0
11|8.0|6|9.0
12|4.0|4|16.0
13|4.0|4|16.0
14|5.0|5|5.0
15|5.0|5|5.0
16|5.0|5|5.0
17|6.0|6|4.2
18|6.0|6|4.2
19|7.0|7|8.0
20|7.0|7|8.0

- 일정하지 않은 간격의 index를 갖고 있는 입력 데이터의 DataFrame이 Interpolation 후 일정한 간격의 index를 갖고 있는 DataFrame으로 출력됨을 확인할 수 있다.
- 존재하지 않던 index의 value들을 methodOption(LINEAR, NEAREST, PREV_COPY)을 설정하여 원하는 값으로 생성할 수 있다.
