---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# Time Synchronize Operator
---
## Operator 설명
두 개의 테이블 (입력 테이블과 파일에서 읽어들인 테이블)을 시간 간격을 동일하게 값을 보간하여 하나의 테이블로 결합한다.

입력 테이블에 포함된 timestamp를 기준으로 파일에서 읽어들인 테이블과 시간을 동기화하여 하나의 테이블로 결합한다. 즉 두 개의 테이블 (입력테이블과 파일에서 읽어들인 테이블)을 일정한 시간 간격으로 값을 보간하여, 하나의 테이블로 결합한다. 파일에서 읽어들인 테이블에 시간 delay가 있을 경우 'hasTimeDelay'를 TRUE로 설정하여 시간을 조정할 수 있다. 즉, 'isAutoMode'를 TRUE로 설정하여 두 테이블의 첫번째 행의 시간을 동일하게 조정하거나, 'timeDelay' 값을 초 단위로 입력하여 조정할 수 있다. 보간방법은 3가지(LINEAR, NEAREST, PREV_COPY)를 제공하며 자세한 내용은 'interpolationInfo' 세부내용을 참고한다.	두 개의 테이블 (입력 테이블과 파일에서 읽어들인 테이블)을 시간 간격을 동일하게 값을 보간하여 하나의 테이블로 결합한다.

## Operator 파라미터 설명
- hasTimeDelay: 파일에서 읽어들인 테이블에 시간 delay가 있을 경우 TRUE로 설정한다. TRUE로 설정한 경우 'isAutoMode' 또는 'timeDelay' 값을 설정하여 시간을 조정한다. (required)
- isAutoMode: 두 테이블의 첫번째 행의 시간을 자동으로 동일하게 조정하고 싶을 경우 TRUE로 설정한다. (optional)
- timeDelay: 시간 delay를 수동으로 조정하고 싶을 경우 초 단위의 정수값을 입력한다. (optional)
- interpolationInfo: 입력테이블의 보간방법을 설정한다. 'indexColumnName'에 timestamp 칼럼 이름을 입력하고, 'stepSize'는 초 단위의 시간 간격을 입력한다. (required)
- isTimeStampColumn: 시간정보를 포함하는 칼럼의 타입이 timestamp인 경우에 TRUE로 설정한다. FALSE로 설정한 경우 'userTimeStampPattern'을 입력하여 timestamp 타입으로 변경하여야 한다. (required)
- userTimeStampPattern: 시간이 기록된 패턴을 입력한다. (optional)
- joinDataInfo: 파일에서 읽어들일 테이블의 파라미터를 설정한다. (required)
